<template>
  <i-wrapper top>
    <i-stepper :total="auth.onboarding.total" :filled="3" />
    <i-curtain tag="form" @submit="submit()">
      <img src="~assets/images/bubbles-orange.svg" class="bubbles bubbles--custom" />
      <img src="~assets/images/scientist-cake.png" class="scientist-cake" />
      <div class="title px-1 text-center">{{ $t(`Wonderful!`) }}</div>
      <div class="normal-text text-center px-1">
        {{ $t(`When's your birthday? A person's date of birth is the foundation of any astrological prediction.`) }}
      </div>
      <template #bottom>
        <i-input
          ref="birthDateInput"
          v-model="birthDate"
          :default-value="defaultBirthDate"
          type="date"
          class="mb-1"
          placeholder="Enter your birthday"
          :flow="['year', 'month', 'date']" />
        <i-button submit block :loading="isLoading" :disabled="isLoading">{{ $t(`CONTINUE`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',

    data() {
      return {
        birthDate: this.$store.state.auth.onboarding.birthDate,
        defaultBirthDate: '1985-01-01',
        isLoading: false,
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    mounted() {
      //
    },

    methods: {
      async submit() {
        if (this.isLoading) {
          return;
        }

        console.log('SUBMIT');

        if (!this.birthDate) {
          this.$refs.birthDateInput.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.birthDateInput.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`onboarding/birth_date`, {
            birthDate: this.birthDate.split('T')[0],
          });

          ga('send', 'event', 'onb_birth_3_date');
          this.$store.commit('MERGE_AUTH', { onboarding: response.data.data, user: response.data.data.user });
          await this.$router.push(this.localePath({ name: 'onboarding.birth-time' }));
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss">
  .scientist-cake {
    width: rw(106px);
    margin-top: rs(30px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    margin-top: rs(15px);
  }

  .normal-text {
    font-size: rf(16px);
    margin-top: rs(15px);
  }

  .bubbles--custom {
    top: rs(147px);
  }
</style>
